#ifndef BqW_autoptr_h
#define BqW_autoptr_h

#include <cstdio>

template <typename t>
class autoptr
{
    t *p;
    void Del() { if(p && !--p->refnum)delete p; }
    void Set(t *a) { if(a)++a->refnum; if(p && !--p->refnum)delete p; p = a; }
public:
    autoptr() : p(NULL) { }
    autoptr(t *const a) { p=a; if(p)++p->refnum; }
    autoptr &operator= (t *const a) { Set(a); return *this; }
    autoptr &operator= (const autoptr<t> &a) { Set(&*a); return *this; }
    t &operator* () const { return *p; }
    t *operator-> () const { return p; }
    // to enable boolean tests with this class: if(tmp) {...}
    operator t *() { return p; }
    bool operator! () const { return !p; }
    ~autoptr() { Del(); }    
    autoptr(const autoptr<t> &a) { p=(t *)&*a; if(p)++p->refnum; }
};
// autoptr must only use ptrable classes.
class ptrable
{
    // This does not compile with some old
    // egcs and gcc compilers. Don't blame
    // me, update your buggy compiler.
    template<class t> friend autoptr<t>;
    int refnum;
public:
    ptrable() : refnum(0) { }
};

#endif
